/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;
#define ll long long
#define mp make_pair
#define maxn 100100
struct pt{
    ll x,y;
};

bool operator< (pt a,pt b)
{
    return a.y<b.y || (a.y==b.y && a.x<b.x);
}

bool cmp(pt a,pt b)
{
    return a.x*b.y>b.x*a.y;
}

int n;
pt a[maxn];
pair<pt, pt> et;

void upd_et(pair<pt, pt> q)
{
    if(q.first.y>q.second.y) swap(q.first,q.second);
    if(q.first.y==q.second.y) return ;
    if(et.first.x==-1)
    {
        et=q;
        return ;
    }
    if(abs(et.first.x-et.second.x)*abs(q.first.y-q.second.y)>abs(q.first.x-q.second.x)*abs(et.first.y-et.second.y)) return ;
    else if(abs(et.first.x-et.second.x)*abs(q.first.y-q.second.y)==abs(q.first.x-q.second.x)*abs(et.first.y-et.second.y))
    {
        et = min(et, q);
    } else et=q;
}

void solve(int p)
{
    int l = 0;
    int r = p-1;
    while(r-l>2)
    {
        int m1 = (l+l+r)/3;
        int m2 = (l+r+r)/3;
        pt p1 = a[m1];
        pt p2 = a[m2];
        p1.x-=a[p].x;
        p1.y-=a[p].y;
        p2.x-=a[p].x;
        p2.y-=a[p].y;
        ll z1 = abs(p1.x*p2.y);
        ll z2 = abs(p2.x*p1.y);
        if(z1>z2) l=m1;
        else r=m2;
    }
    if(l<n) upd_et(mp(a[p],a[l]));
    if(l+1<p) upd_et(mp(a[p],a[l+1]));
    if(r<p) upd_et(mp(a[p],a[r]));
}

int main()
{
freopen("slope.in","r",stdin);
freopen("slope.out","w",stdout);
    scanf("%d",&n);
    for(int i=0;i<n;++i)
        scanf("%lld%lld",&a[i].x,&a[i].y);
    et.first.x=-1;
    sort(a,a+n,cmp);
    for(int i=1;i<n;++i)
        solve(i);
    if(et.first.x==-1) puts("0");
    else cout << et.first.x << " " << et.first.y << " " << et.second.x << " " << et.second.y << "\n";
    return 0;
}
