/* GCC */
#include <iostream>
#include <math.h>

using namespace std;

int main() {
	freopen("slope.in", "r", stdin);
	freopen("slope.out", "w", stdout);
	
	int n=0;
	cin >> n;
	int dotsX[n];
	int dotsY[n];
	
	for(int i=0;i<n;i++){
		cin >> dotsX[i];
		cin >> dotsY[i];
	}
	
	int mingrad=abs(dotsX[0]-dotsX[1])/abs(dotsY[0]-dotsY[1]);
	
	int minxj=dotsX[0];
	int minyj=dotsY[0];
	int minxk=dotsX[1];
	int minyk=dotsY[1];
	
	int nowgrad=0;
		
	for(int i=0;i<(n-1);i++) {
		for(int j=(i+1);j<n;j++) {
			if((dotsY[i] - dotsY[j])!=0) nowgrad = abs(dotsX[i] - dotsX[j])/(dotsY[i] - dotsY[j]);
			if( nowgrad > mingrad ) {
				mingrad=nowgrad;
				minxj=dotsX[i];
				minyj=dotsY[i];
				minxk=dotsX[j];
				minyk=dotsY[j];
			}
			 else if( nowgrad==mingrad ) {
				if( dotsY[i]<minyj ) {
					mingrad=nowgrad;
					minxj=dotsX[i];
					minyj=dotsY[i];
					minxk=dotsX[j];
					minyk=dotsY[j];
				} else if(dotsY[i]==minyj) {
					if( dotsX[i]<minxj ) {
						mingrad=nowgrad;
						minxj=dotsX[i];
						minyj=dotsY[i];
						minxk=dotsX[j];
						minyk=dotsY[j];
					} else if (dotsX[i]==minxj) {
						if( dotsY[j]<minyk ) {
							mingrad=nowgrad;
							minxj=dotsX[i];
							minyj=dotsY[i];
							minxk=dotsX[j];
							minyk=dotsY[j];
						} else if(dotsY[j]==minyk) {
							if( dotsX[j]<minxk ) {
								mingrad=nowgrad;
								minxj=dotsX[i];
								minyj=dotsY[i];
								minxk=dotsX[j];
								minyk=dotsY[j];
							}
						}
					}
				}
			}
		}
	}
	
	if( minyj<minyk ) {
		cout << minxj << " " << minyj << " " << minxk << " " << minyk;	
	} else {
		cout << minxk << " " << minyk << " " << minxj << " " << minyj;
	}
	
	
	cout << endl;
	
	return 0;	
}
