/* GCC */
#include <stdio.h>
#include <math.h>
#include <algorithm>
using namespace std;

#define NMAX 100010

int n;
double mx=-1;
struct krd{
	int x,y;
	int ye;
}t[NMAX],rs[2];

bool cmp(krd a,krd b){
	if(a.y == b.y){
		return a.x < b.x;
	}
	return a.y < b.y;
}

inline void upd(int a,int b){
	double r = abs((t[a].x-t[b].x)/(t[a].y-t[b].y));
	if(r > mx){
		mx = r;
		rs[0] = t[b];
		rs[1] = t[a];
	}
}

int main(){
	freopen("slope.in","r",stdin);
	freopen("slope.out","w",stdout);
	int i,j;
	scanf("%d",&n);
	for(i=0;i<n;++i){
		scanf("%d %d",&t[i].x,&t[i].y);
	}

	sort(t,t+n,cmp);
	for(i=0;i<n-1;++i){
		j = i;
        while(i < n && t[i].y == t[j].y) ++i;
        --i;
		t[j].ye = i;
		t[i].ye = i;
	}
	t[n-1].ye = n-1;

	for(i=0;i<n-1;++i){
		j = t[i].ye+1;
		upd(j,i);

		j = t[j].ye;
		upd(j,i);

		if(t[i].ye != i) i = t[i].ye-1;
	}

	if(mx < 0){
		printf("0\n");
	}else{
		printf("%d %d %d %d\n",rs[0].x,rs[0].y,rs[1].x,rs[1].y);
	}
}
