/* GCC */
#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>

using namespace std;

long m, n, p, r, i;
long long ar_a[32768], ar_b[32768], *a = ar_a, *b = ar_b;

long payed_10s, payed_20s, left_10s, q_10s, q_20s;

int main() {
    freopen("cash.in", "r", stdin);
    freopen("cash.out", "w", stdout);

    scanf("%d %d %d %ld", &m, &n, &p, &r);

    for(i = 0; i <= n + m; i++) {
        a[i] = b[i] = 0;
    }
    a[0] = 1;

    for(i = 0; i < n + m; i++) {
        for(payed_20s = 0; payed_20s <= i; payed_20s++) {
            payed_10s = i - payed_20s;
            left_10s = p + payed_10s - payed_20s;
            q_10s = n - payed_10s;
            q_20s = m - payed_20s;

            if(!r) {
                if(q_10s) {
                    b[payed_20s] += a[payed_20s];
                }
                if(left_10s && q_20s) {
                    b[payed_20s + 1] += a[payed_20s];
                }
            } else {
                if(q_10s) {
                    b[payed_20s] = (b[payed_20s] + a[payed_20s]) % r;
                }
                if(left_10s && q_20s) {
                    b[payed_20s + 1] += (b[payed_20s + 1] + a[payed_20s]) % r;
                }
            }
        }
        swap(a, b);
        memset(b, 0, sizeof(long long)*(i + 1));
    }

    cout << a[m] << endl;

    return 0;
}
