/* GCC */
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <algorithm>
#include <list>

#define abs(A) (((A)<0)?(-(A)):(A))

using namespace std;

template<class _T1> struct point : public pair<_T1,_T1> {};
typedef point<point<double> > lii;
typedef list<lii > li;
inline double get_angle(std::pair<point<double>, point<double> > p) {
    return abs(p.first.first-p.second.first) / abs(p.first.second - p.second.second);
}

int main() {
    freopen("slope.in","r",stdin);
    freopen("slope.out","w",stdout);
    int n,i;
    cin >> n;
    point < double> _a[n];
    for (i=0; i<n; i++)
        cin >> _a[i].first >> _a[i].second;
    sort(_a,_a+n);
    li a(--n);
    li::iterator it,i1,i2;
    double a1,a2;
    const double inf = 1.0/0.0;
    point<double> e;
    for (it=a.begin(),i=0; it!=a.end(); it++,i++) {
        (*it).first = _a[i];
        (*it).second = _a[i+1];
    }
    bool f = true;
    while (f) {
        f = false;
        for (it=a.begin(); it!=a.end();) {
            i1 = it++;
            if (it!=a.end()) {
                a1 = get_angle(*i1);
                a2 = get_angle(make_pair(e = i1->first,it->second));
                if (a2 == inf)
                    continue;
                if (a1<a2||a1==inf) {
                    f = true;
                    it = a.erase(--it);
                    it->first = e;
                }
            }
        }
    }
    std::pair<point<double>, point<double> > mi = *(it=a.begin());
    if (mi.first.second > mi.second.second)
            swap(mi.first,mi.second);
    for (it++; it!=a.end(); it++){
        if (get_angle(*it)==inf)
            continue;
        if (it->first.second > it->second.second)
            swap(it->first,it->second);
        if (get_angle(*it)<get_angle(mi)||get_angle(mi)==inf)
            mi = *it;
        if (get_angle(*it)==get_angle(mi)){
            if (mi.first.second > it->first.second)
                mi = *it;
            else if (mi.first.first > it->first.first)
                mi = *it;
            else if (mi.second.second > it->second.second)
                mi = *it;
            else if (mi.second.first > it->second.first)
                mi = *it;
        }
    }
    if (get_angle(mi) == inf)
        cout << 0 << '\n';
    else
        cout << mi.first.first << ' '<<mi.first.second << ' '<<mi.second.first << ' ' <<mi.second.second << '\n';
    return 0;
}
