/* GCC */
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cstdio>

using namespace std;

const int NMAX = 100010;
const int COUNT = 100;
typedef pair <int, int> pii;
typedef long double ld;
#define x first
#define y second

int n;
pii a[NMAX];
int xj, xk, yj, yk;

bool Less(pii a, pii b) { return (a.y < b.y) || (a.y == b.y && a.x < b.x); }

int main()
{
    freopen("slope.in", "r", stdin);
    freopen("slope.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d %d", &a[i].x, &a[i].y);

    sort(a, a + n, Less);

    ld ans = 0;
    xj = xk = yj = yk = 300000;

    for (int j = 0; j < n; ++j)
        for (int k = j + 1, i = 0; k < n && i < COUNT; ++k, ++i)
            if (a[j].y < a[k].y)
            {
                int dy = abs(a[k].y - a[j].y);
                if (dy != 0)
                {
                    int dx = abs(a[j].x - a[k].x);
                    if ((ld)dx / (ld)dy >= ans)
                    {
                        if (a[j].y < yj)
                            ans = (ld)dx / (ld)dy,
                            xj = a[j].x, yj = a[j].y, xk = a[k].x, yk = a[k].y;
                        else
                            if (a[j].y == yj && a[j].x < xj)
                                ans = (ld)dx / (ld)dy,
                                xj = a[j].x, yj = a[j].y, xk = a[k].x, yk = a[k].y;
                            else
                                if (a[j].x == xj && a[k].y < yk)
                                    ans = (ld)dx / (ld)dy,
                                    xj = a[j].x, yj = a[j].y, xk = a[k].x, yk = a[k].y;
                                else
                                    if (a[k].y == yk && a[k].x < xk)
                                        ans = (ld)dx / (ld)dy,
                                        xj = a[j].x, yj = a[j].y, xk = a[k].x, yk = a[k].y;
                    }
                }
            }

    if (ans == 0)
    {
        printf("0\n");
        return 0;
    }
    if (yj > yk)
        swap(xj, xk), swap(yj, yk);
    printf("%d %d %d %d\n", xj, yj, xk, yk);
    return 0;
}
