/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <math.h>

using namespace std;

int main()
{
    ifstream fin("slope.in");
    int n;
    fin >> n;
    vector<pair<int, int> > slopes(n);
    vector<vector<double> > res;

    for (int i = 0; i < n; i++) {
        fin >> slopes[i].first >> slopes[i].second;
    }

    for (int j = 0; j < slopes.size(); j++) {

        for (int k = j; k < slopes.size(); k++) {
            if (k != j && slopes[j].second != slopes[k].second) {
                vector<double> vect(3);
                vect[0] = (double)abs(slopes[j].first - slopes[k].first) / abs(slopes[j].second - slopes[k].second);
                vect[1] = j;
                vect[2] = k;
                res.push_back(vect);
            }
        }
    }

    double maximum = 0;
    pair<int, int> dot_j, dot_k;
    dot_j.first, dot_j.second = 0 , 0;
    dot_k.first, dot_k.second = 0 , 0;

    for (int m = 0; m < res.size(); m++) {
        if (maximum < res[m][0]) {
            maximum = res[m][0];
            dot_j = slopes[res[m][1]];
            dot_k = slopes[res[m][2]];
        } else if (maximum == res[m][0]) {
            if (slopes[res[m][1]].second < dot_j.second) {
                dot_j = slopes[res[m][1]];
                dot_k = slopes[res[m][2]];
            } else if (slopes[res[m][1]].second == dot_j.second) {
                if (slopes[res[m][1]].first < dot_j.first) {
                    dot_j = slopes[res[m][1]];
                    dot_k = slopes[res[m][2]];
                } else if (slopes[res[m][1]].first == dot_j.first) {
                    if (slopes[res[m][2]].second < dot_k.second) {
                        dot_j = slopes[res[m][1]];
                        dot_k = slopes[res[m][2]];
                    } else if (slopes[res[m][2]].second == dot_k.second) {
                        if (slopes[res[m][2]].first < dot_k.first) {
                            dot_j = slopes[res[m][1]];
                            dot_k = slopes[res[m][2]];
                        }
                    }
                }
            }
        }
    }

    if (dot_j.second > dot_k.second) dot_j, dot_k = dot_k, dot_j;

    ofstream fout("slope.out");

    if (maximum == 0) {
        fout << 0 << endl;
        return 0;
    }

    fout << dot_j.first << " " << dot_j.second << " " << dot_k.first << " " << dot_k.second << endl;

    return 0;
}
