/* GCC */

#define maxn 256

#include <stdio.h>

using namespace std;

int k[maxn][2], nk = 0, nimb[maxn + 1], ind[2 * maxn]; //nk starts from 0 !

inline int findnimb(int n, int g)
{
    for (int i = 0; i < 2 * n; i++)
        ind[i] = 0;
    for (int i = 1; i <= g; i++)
    {
        for (int j = 1; j <= n + 1 - i; j++)
        {
            int nim2 = nimb[j - 1] xor nimb[n + 1 - j - i];
            ind[nim2]++;
        }
    }
    int nimber = 0;
    while (ind[nimber] > 0)
        nimber++;
    return nimber;
}

int main()
{
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    int g, x, last, maxk = 0;
    scanf("%d", &g);
    scanf("%d", &x);
    k[0][1] = x;
    k[0][0] = 1;
    last = x;
    while (scanf("%d", &x) > 0)
    {
        if (x != last + 1)
        {
            nk++;
            k[nk][0] = 0;
            k[nk][1] = x;
        }
        k[nk][0]++;
        if (k[nk][0] > maxk)
            maxk = k[nk][0];
        last = x;
    }
    nimb[0] = 0;
    for (int i = 1; i <= maxk; i++)
        nimb[i] = findnimb(i, g);
    int nimber = 0;
    for (int i = 0; i <= nk; i++)
        nimber = nimber xor nimb[k[i][0]];
    for (int i = 1; i <= g; i++) //find answers
    {
        if (nimber > 0)
        {
            for (int j = 0; j <= nk; j++)
            {
                nimber = nimber xor nimb[k[j][0]];
                for (int l = 1; l <= k[j][0] + 1 - i; l++)
                {
                    int nim2 = nimb[l - 1] xor nimb[k[j][0] + 1 - l - i];
                    if (nim2 == nimber)
                        printf("%d ", k[j][1] + l - 1);
                }
                nimber = nimber xor nimb[k[j][0]];
            }
        }
        printf("\n");
    }
    return 0;
}
