/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

long long factorial(int a) {
    long long res = 1;
    while (a > 1) {
        res = res * a;
        a--;
    }
    return res;
}

long long maxExchanges(int a, int b) {
    if (a < b) swap(a, b);
    long long topTemp = 1;
    for (int i = a + 1; i < a + b + 1; i++) {
        topTemp = topTemp * i;
    }

    long long form = topTemp / factorial(b);
    return form;
}

int main() {
    ifstream fin("cash.in");
    ofstream fout("cash.out");

    int tMoney, oMoney, startMoney, ostacha;
    fin >> tMoney >> oMoney >> startMoney >> ostacha;
    fin.close();

    if (oMoney + startMoney > 2 * tMoney) {
        if (ostacha == 0){
            fout << maxExchanges(tMoney, oMoney);
        }
        else {
            fout << maxExchanges(tMoney, oMoney) % ostacha;
        }
    }

    fout << endl;
    fout.close();
    return 0;
}
