/* GCC */
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <time.h>
#include <iomanip>

#define ll long long
#define ld long double
#define pii pair<int, int>
#define mp make_pair

#define MAX 100010
#define INF 1000000007
#define eps 0.000001
using namespace std;

const ld start = (ld) (-1000000000000000.0);
int n;
pii F, S, a[MAX];

inline bool cmp(pii a, pii b){
if (a.second!=b.second) return a.second<b.second;
return a.first<b.first;
}

inline bool cmp2(pii a, pii b){
if (a.second!=b.second) return a.second<b.second;
return a.first>b.first;
}

inline ld calc(pii& a, pii& b){
    if (a.second==b.second) return start;
  ld D = abs((a.first-b.first+0.0)/(a.second-b.second));
  return D;
}

/*
54 22336 29643 22337
29589.000000
230 603 29920 604
29690.000000

*/
int startt = clock();

inline void out(pii a){
cout << a.first << " " << a.second << " ";
 }


 inline void sort1(){
vector<pii> g[30001];
for (int i=0; i<n; i++) {
    g[a[i].second].push_back(a[i]);
}
int t=0;
for (int i=0; i<=30000; i++) {
    sort(g[i].begin(), g[i].end(), cmp);
    for (int j=0; j<g[i].size(); j++){
        a[t] = g[i][j];
        t++;
    }
}

 }

 inline void sort2(){
vector<pii> g[30001];
for (int i=0; i<n; i++) {
    g[a[i].second].push_back(a[i]);
}
int t=0;
for (int i=0; i<=30000; i++) {
    sort(g[i].begin(), g[i].end(), cmp2);
    for (int j=0; j<g[i].size(); j++){
        a[t] = g[i][j];
        t++;
    }
}

 }

//230 603 29920 604
void good(){
// sort(a, a+n, cmp);
 sort1();
  // for (int i=0; i<n; i++) cout << a[i].first << " " << a[i].second << endl;
//exit(0);
    ld d = start;
    F = mp(-1, -1);
    for (int i=1; i<n; i++){
        if (a[i].second==a[i-1].second) continue;
        ld D = calc(a[i], a[i-1]);
       // out(a[i]);
       // out(a[i-1]);
        //cout << setprecision(3) << fixed << D << endl;
        if (D>d+eps) {
                F = a[i];
                S = a[i-1];
                d = D;
        }
    }
    if ((clock()-startt)*2<0.5*CLOCKS_PER_SEC)
        {
        //sort(a, a+n, cmp2);
        sort2();
        for (int i=1; i<n; i++){
                if (clock()-startt>0.43*CLOCKS_PER_SEC) break;
            if (a[i].second==a[i-1].second) continue;
            ld D = calc(a[i], a[i-1]);
            if (abs(D-d)<eps) continue;
            if (D>d+eps) {
                    F = a[i];
                    S = a[i-1];
                    d = D;
            }
        }
    }
   // exit(0);
    if (abs(d-start)<eps) {
        puts("0");
        exit(0);
    }
    if (F.second>S.second) swap(F, S);
    if (F.second==S.second && F.first>S.first) swap(F, S);
    cout << F.first << " " << F.second << " ";
    cout << S.first << " " << S.second << endl;
   // cout << setprecision(6) << fixed << d << endl;
   // exit(0);
}

void brute(){
    F = mp(-1, -1);
     ld d = start;
for (int j=0; j<n; j++)
    for (int k=0; k<n; k++) {
            if (j==k) continue;

    //puts("1");
   // cout << j << " " << k << endl;
        ld D = calc(a[j], a[k]);
       // cout << setprecision(3) << fixed << D << endl;
        if (D>d+eps) {
                //if (a[i].second>a[j].second)
                F = a[j];
                S = a[k];
                d = D;
        }
    }
    if (abs(d-start)<eps) {
        puts("0");
        exit(0);
    }

    for (int j=0; j<n; j++)
    for (int k=0; k<n; k++) {
        ld D = calc(a[j], a[k]);
       // cout << setprecision(3) << fixed << D << endl;
        if (abs(D-d)<eps) {
                //if (a[i].second>a[j].second)
                if (a[j].second<F.second) {
                    F = a[j];
                    S = a[k];
                }
                if (a[j].second==F.second && a[j].first<F.first) {
                    F = a[j];
                    S = a[k];
                }
                if (a[j].second==F.second && a[j].first==F.first && a[k].second<S.second){
                    F = a[j];
                    S = a[k];

                }
                if (a[j].second==F.second && a[j].first==F.first && a[k].second==S.second && a[k].first<S.first){
                    F = a[j];
                    S = a[k];

                }
        }
    }
    cout << F.first << " " << F.second << " ";
    cout << S.first << " " << S.second << endl;
     //cout << setprecision(6) << fixed << d << endl;
    //exit(0);
}

void nxi(int& n){
n=0; bool min = 0; char c;
while ((c = getchar()) && c<32) ;
if (c=='-') min = 1; else n = c - '0';
while ((c = getchar()) && c>32) n = (n << 3 ) + ( n << 1) + c - 48;
if (min) n = -n;
}

int main()
{
    freopen("slope.in", "r", stdin); freopen("slope.out", "w", stdout);
//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i=0; i<n; i++) {
       //scanf("%d %d", &a[i].first, &a[i].second);
       nxi(a[i].first);
       nxi(a[i].second);
       //cout << a[i].first << " " << a[i].second << endl;
    }
   // if (n<1000) brute(); else
     brute();
        good();
   // brute();






    return 0;
}
