/* GCC */
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

long n, i;
short xmn[30001], xmx[30001], j, k, x1, x2;

pair<short, short> rj, rk;
double fpt, fpt_bst = -1;

inline bool ok(short _xj, short _yj, short _xk, short _yk) {
    if(_yj < rj.second) return true;
    if(_yj > rj.second) return false;
    if(_xj < rj.first) return true;
    if(_xj > rj.first) return false;
    if(_yk < rk.second) return true;
    if(_yk > rk.second) return false;
    if(_xk < rk.first) return true;
    if(_xk > rk.first) return false;
}

int main() {
    for(j = 0; j <= 30000; j++) {
        xmn[j] = 30001;
        xmx[j] = -1;
    }

    freopen("slope.in", "r", stdin);
    freopen("slope.out", "w", stdout);

    scanf("%ld", &n);

    for(i = 0; i < n; i++) {
        scanf("%d%d", &j, &k);
        if(xmn[k] > j) xmn[k] = j;
        if(xmx[k] < j) xmx[k] = j;
    }

    for(j = 0; j <= 30000; j++) {
        if(xmn[j] <= 30000) {
            for(k = j + 1; k <= 30000; k++) {
                if(xmn[k] <= 30000) {
                     x1 = xmn[j]; x2 = xmx[k];
                     fpt = x1 != x2 ? abs(x1 - x2)/(k - j) : 0;
                     if(fpt == fpt_bst) {
                         if(ok(x1, j, x2, k)) {
                             fpt_bst = fpt;
                             rj = make_pair(x1, j);
                             rk = make_pair(x2, k);
                         }
                     } else if(fpt > fpt_bst) {
                         fpt_bst = fpt;
                         rj = make_pair(x1, j);
                         rk = make_pair(x2, k);
                     }
                     x1 = xmx[j]; x2 = xmn[k];
                     fpt = x1 != x2 ? abs(x1 - x2)/(k - j) : 0;
                     if(fpt == fpt_bst) {
                         if(ok(x1, j, x2, k)) {
                             fpt_bst = fpt;
                             rj = make_pair(x1, j);
                             rk = make_pair(x2, k);
                         }
                     } else if(fpt > fpt_bst) {
                         fpt_bst = fpt;
                         rj = make_pair(x1, j);
                         rk = make_pair(x2, k);
                     }
                }
            }
        }
    }

    if(fpt_bst == -1) {
        puts("0");
    } else {
        printf("%d %d %d %d\n", rj.first, rj.second, rk.first, rk.second);
    }


    return 0;
}
