/* GCC */

#include <iostream>
#include <vector>
#include <fstream>
using namespace std;

void swa(int &x, int &y)
{
    int z = x;
    x = y;
    y = z;
}

void recsort1 (int be, int en, vector <int> &a)
{
    int t = (be + en) / 2;
    int x = a[t];
    t = be;
    int k = be - 1;
    int m = en + 1;
    while (t < m)
    {
        if (a[t] > x)
        {
            m--;
            swa(a[t],a[m]);
        }
        else
        {
            if (a[t] < x)
            {
                k++;
                swa(a[t],a[k]);
            }
            t++;
        }
    }
    if (k > be) recsort1 (be, k, a);
    if (m < en) recsort1 (m, en, a);
}

void recsort2 (int be, int en, vector <int> &a, vector <int> &b)
{
    int t = (be + en) / 2;
    int x = a[t];
    t = be;
    int k = be - 1;
    int m = en + 1;
    while (t < m)
    {
        if (a[t] > x)
        {
            m--;
            swa(a[t],a[m]);
            swa(b[t],b[m]);
        }
        else
        {
            if (a[t] < x)
            {
                k++;
                swa(a[t],a[k]);
                swa(b[t],b[k]);
            }
            t++;
        }
    }
    recsort1 (k + 1, m - 1, b);
    if (k > be) recsort2(be,k,a,b);
    if (m < en) recsort2(m,en,a,b);
}

int main()
{
    ifstream fin;
    fin.open ("slope.in");
    int n;
    fin >> n;
    vector <int> x(n);
    vector <int> y(n);
    for (int t = 0; t < n; t++)
        fin >> x[t] >> y[t];
    fin.close();

    recsort2(0, n-1, y, x);
    double f = 0;
    int j = 0;
    int k = 0;

    for (int t = 0; t < n; t++)
        for (int i = 0; i < n; i++)
            if ((i != t) && (y[i] != y[t]))
            {
                double l = (x[i] - x[t]) / (y[i] - y[t]);
                if (l < 0) l = -l;
                if (l > f)
                {
                    j = t;
                    k = i;
                    f = l;
                }
            }

    ofstream fout;
    fout.open("slope.out");
    if (f == 0) fout << f << endl;
    else fout << x[j] << " " << y[j] << " " << x[k] << " " << y[k] << endl;
    fout.close();

    return 0;
}
