/* GCC */

#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

struct Point
{
    Point (int x_ = -1, int y_ = -1)
    {
        x = x_, y = y_;
    }


    int x, y;
};

struct Line
{

    void point (Point p1_, Point p2_)
    {
        if (p1_.y > p2_.y)
            swap (p1_, p2_);

        if (p1.x != -1)
        {
            if (p1_.y > p1.y)
                return;
            if (p1_.y == p1.y && p1_.x > p1.x )
                return;
            if (p1_.y == p1.y && p1_.x == p1.x && p2_.x > p2.x)
                return;
        }

        p1 = p1_;
        p2 = p2_;
    }
    Point p1, p2;
};

const int nMax = 100016;

vector<Point> points(nMax);

Line l;
int n;
double a = -1;

void bad_sol ()
{
    for (int i = 0; i < n - 1; i++)
        for (int j = i + 1; j < n; j++)
        {
            Point p1 = points[i];
            Point p2 = points[j];

            if ( p1.y == p2.y )
                continue;

            double a1 = abs (p1.x - p2.x) / (double)abs (p1.y - p2.y);
            if ( a1 >= a )
                a = a1, l.point (p1, p2);

        }
}

int main ()
{
    freopen ("slope.in", "r", stdin);
    freopen ("slope.out", "w", stdout);

    scanf ("%d", &n);

    for (int i = 0; i < n; i++)
        scanf ("%d %d", &points[i].x, &points[i].y);

    bad_sol ();

    if (a != -1)
        printf ("%d %d %d %d\n", l.p1.x, l.p1.y, l.p2.x, l.p2.y);
    else
        printf ("0\n");

    return 0;
}
