/* GCC */

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef unsigned int uint;

struct point
{
       int x, y;
};
struct point2
{
       point p1, p2;
};

vector<point> pairs;

int main()
{
    ifstream ifs("slope.in");

    uint n;
    ifs >> n;
    pairs.reserve(n);

    for(uint i = 0; i < n; ++i)
    {
        point p;
        ifs >> p.x >> p.y;
        pairs.push_back(p);
    }
    ifs.close();

    double max = 0;
    vector<point2> res;

    for(int k = n-1; k >=0; --k)
    {
        point p = pairs[k];
        pairs.pop_back();

        for(int i = pairs.size()-1; i >=0; --i)
        {
            int xjk = abs(p.x - pairs[i].x), yjk = abs(p.y - pairs[i].y);
            //int xjk2 = abs(pairs[i].x - p.x), yjk2 = abs(pairs[i].y - p.y);
            double m = (double)xjk / (double)yjk;
            //double m2 = (double)xjk2 / (double)yjk2;
            if(yjk != 0 && m > max)
            {
                max = m;
                //p1 = p;
                point2 pp;
                /*if(p.y < pairs[i].y)
                {*/
                    pp.p1 = p;
                    pp.p2 = pairs[i];
                /*}
                else{
                    pp.p1 = pairs[i];
                    pp.p2 = p;
                }*/
                res.push_back(pp);

            }
            else if(m == max && m != 0)
            {
                point2 pp;
                /*if(p.y < pairs[i].y)
                {*/
                    pp.p1 = p;
                    pp.p2 = pairs[i];
                /*}
                else{
                    pp.p1 = pairs[i];
                    pp.p2 = p;
                }*/
                res.push_back(pp);
            }
        }
    }

    ofstream ofs("slope.out");
    if(max == 0)
        ofs << 0;
    else {
    point2 result = res[0];
    /*if(res.size() == 1)
        result = res[0];
    else
    {
        vector<point2> r1;
        uint y1min = -1;

        for(int i = 0; i < res.size(); ++i)
            if(res[i].p1.y < y1min)
                y1min = res[i].p1.y;
        for(int i = 0; i < res.size(); ++i)
            if(res[i].p1.y == y1min)
                r1.push_back(res[i]);
        if(r1.size() > 1)
        {
            vector<point2> r2;
            uint x1min = -1;

            for(int i = 0; i < res.size(); ++i)
                if(res[i].p1.x < x1min)
                    x1min = res[i].p1.x;
            for(int i = 0; i < res.size(); ++i)
                if(res[i].p1.x == x1min)
                    r2.push_back(res[i]);
            if(r2.size() > 1)
            {
                vector<point2> r3;
                uint y2min = -1;

                for(int i = 0; i < res.size(); ++i)
                    if(res[i].p2.y < y2min)
                        y1min = res[i].p2.y;
                for(int i = 0; i < res.size(); ++i)
                    if(res[i].p2.y == y1min)
                        r3.push_back(res[i]);
                if(r2.size() > 1)
                {
                    vector<point2> r4;
                    uint x2min = -1;

                    for(int i = 0; i < res.size(); ++i)
                        if(res[i].p2.x < x2min)
                            x1min = res[i].p2.x;
                    for(int i = 0; i < res.size(); ++i)
                        if(res[i].p2.x == x2min)
                            r4.push_back(res[i]);
                    result = r4[0];
                }
                else
                    result = r3[0];
            }
            else
                result = r2[0];
        }
        else
            result = r1[0];
    }*/


        if(result.p1.y > result.p2.y)
        {
            ofs << result.p2.x << " " << result.p2.y << " ";
            ofs << result.p1.x << " " << result.p1.y;
        }
        else
        {
            ofs << result.p1.x << " " << result.p1.y << " ";
            ofs << result.p2.x << " " << result.p2.y;
        }
    }
    ofs.close();

    //cin.get();

    return 0;
}
